using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine;
using UnityEngine.SceneManagement;
using System.Linq;
using TMPro;
using UnityEngine.UI;

namespace Armor
{
    public class Mod
    {
        public static void Main()
        {
CategoryBuilder.Create("WL", "This mod contains warlords and militants", ModAPI.LoadSprite("Categorythumbnail.png")); 

            ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("AK-47"),
                 NameOverride = "AK-12 - WL",
                 DescriptionOverride = "adniawndiuawjdi",
                 CategoryOverride = ModAPI.FindCategory("WL"),
                 ThumbnailOverride = ModAPI.LoadSprite("Guns/ak12icon.png", 5f),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Guns/ak12.png", 2.6f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                     customCartridge.name = "9mm";
                     customCartridge.Damage *= 3f;
                     customCartridge.StartSpeed *= 2.5f;
                     customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                     customCartridge.Recoil *= 3f;
                     customCartridge.ImpactForce *= 3f;
                     firearm.Cartridge = customCartridge;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("Sounds/ak12.mp3"),
                     };
                 }
             }
             ); ;

            ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
                 NameOverride = "Colt M4A1 - WL",
                 DescriptionOverride = "adniawndiuawjdi",
                 CategoryOverride = ModAPI.FindCategory("WL"),
                 ThumbnailOverride = ModAPI.LoadSprite("Guns/coltm4a1icon.png", 5f),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Guns/coltm4a1.png", 2.6f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                     customCartridge.name = "9mm";
                     customCartridge.Damage *= 3f;
                     customCartridge.StartSpeed *= 2.5f;
                     customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                     customCartridge.Recoil *= 3f;
                     customCartridge.ImpactForce *= 3f;
                     firearm.Cartridge = customCartridge;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("Sounds/coltm4a1.mp3"),
                     };
                 }
             }
             ); ;

            ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("AK-47"),
                 NameOverride = "Sig SG-540 - WL",
                 DescriptionOverride = "adniawndiuawjdi",
                 CategoryOverride = ModAPI.FindCategory("WL"),
                 ThumbnailOverride = ModAPI.LoadSprite("Guns/sg-540icon.png", 5f),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Guns/sg-540.png", 2.6f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                     customCartridge.name = "9mm";
                     customCartridge.Damage *= 3f;
                     customCartridge.StartSpeed *= 2.5f;
                     customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                     customCartridge.Recoil *= 3f;
                     customCartridge.ImpactForce *= 3f;
                     firearm.Cartridge = customCartridge;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("Sounds/sg-540.mp3"),
                     };
                 }
             }
             ); ;

            ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("AK-47"),
                 NameOverride = "Sig SG-540 (Scope) - WL",
                 DescriptionOverride = "adniawndiuawjdi",
                 CategoryOverride = ModAPI.FindCategory("WL"),
                 ThumbnailOverride = ModAPI.LoadSprite("Guns/sg-540scopeicon.png", 5f),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Guns/sg-540scope.png", 2.6f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                     customCartridge.name = "9mm";
                     customCartridge.Damage *= 3f;
                     customCartridge.StartSpeed *= 2.5f;
                     customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                     customCartridge.Recoil *= 3f;
                     customCartridge.ImpactForce *= 3f;
                     firearm.Cartridge = customCartridge;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("Sounds/sg-540.mp3"),
                     };
                 }
             }
             ); ;

            ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("AK-47"),
                 NameOverride = "AK-47 - WL",
                 DescriptionOverride = "adniawndiuawjdi",
                 CategoryOverride = ModAPI.FindCategory("WL"),
                 ThumbnailOverride = ModAPI.LoadSprite("Guns/akmicon.png", 5f),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Guns/akm.png", 2.6f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                     customCartridge.name = "9mm";
                     customCartridge.Damage *= 3f;
                     customCartridge.StartSpeed *= 2.5f;
                     customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                     customCartridge.Recoil *= 3f;
                     customCartridge.ImpactForce *= 3f;
                     firearm.Cartridge = customCartridge;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("Sounds/akm.mp3"),
                     };
                 }
             }
             ); ;

            ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("AK-47"),
                 NameOverride = "RPK - WL",
                 DescriptionOverride = "adniawndiuawjdi",
                 CategoryOverride = ModAPI.FindCategory("WL"),
                 ThumbnailOverride = ModAPI.LoadSprite("Guns/rpkicon.png", 5f),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Guns/rpk.png", 2.1f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                     customCartridge.name = "9mm";
                     customCartridge.Damage *= 3f;
                     customCartridge.StartSpeed *= 2.5f;
                     customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                     customCartridge.Recoil *= 3f;
                     customCartridge.ImpactForce *= 3f;
                     firearm.Cartridge = customCartridge;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("Sounds/rpk.mp3"),
                     };
                 }
             }
             ); ;

            ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
                 NameOverride = "Vektor R4 - WL",
                 DescriptionOverride = "adniawndiuawjdi",
                 CategoryOverride = ModAPI.FindCategory("WL"),
                 ThumbnailOverride = ModAPI.LoadSprite("Guns/VektorR4icon.png", 5f),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Guns/VektorR4.png", 2.7f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                     customCartridge.name = "9mm";
                     customCartridge.Damage *= 3f;
                     customCartridge.StartSpeed *= 2.5f;
                     customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                     customCartridge.Recoil *= 3f;
                     customCartridge.ImpactForce *= 3f;
                     firearm.Cartridge = customCartridge;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("Sounds/VektorR4.mp3"),
                     };
                 }
             }
             ); ;

            ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Pistol"),
                 NameOverride = "Glock 17 - WL",
                 DescriptionOverride = "adniawndiuawjdi",
                 CategoryOverride = ModAPI.FindCategory("WL"),
                 ThumbnailOverride = ModAPI.LoadSprite("Guns/glockicon.png", 5f),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Guns/glock.png", 1.9f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                     customCartridge.name = "9mm";
                     customCartridge.Damage *= 3f;
                     customCartridge.StartSpeed *= 2.5f;
                     customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                     customCartridge.Recoil *= 3f;
                     customCartridge.ImpactForce *= 3f;
                     firearm.Cartridge = customCartridge;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("Sounds/glock.mp3"),
                     };
                 }
             }
             ); ;

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Feild Cap 1 - WL", 
                    DescriptionOverride = "Utility Cover", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/Cap1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/Cap1.png", 3f); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/Cap1.png", 3f);
                        prop.armorPoints = 300;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Feild Cap 2 - WL", 
                    DescriptionOverride = "Utility Cover", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/Cap2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/Cap2.png", 3f); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/Cap2.png", 3f);
                        prop.armorPoints = 300;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Feild Cap 3 - WL", 
                    DescriptionOverride = "Utility Cover", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/Cap3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/Cap3.png", 3f); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/Cap3.png", 3f);
                        prop.armorPoints = 300;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Feild Cap 4 - WL", 
                    DescriptionOverride = "Utility Cover", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/Cap4icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/Cap4.png", 3f); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/Cap4.png", 3f);
                        prop.armorPoints = 300;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Feild Cap 5 - WL", 
                    DescriptionOverride = "Utility Cover", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/Cap5icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/Cap5.png", 3f); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/Cap5.png", 3f);
                        prop.armorPoints = 300;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Feild Cap 6 - WL", 
                    DescriptionOverride = "Utility Cover", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/Cap6icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/Cap6.png", 3f); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/Cap6.png", 3f);
                        prop.armorPoints = 300;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Feild Cap 7 - WL", 
                    DescriptionOverride = "Utility Cover", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/Cap7icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/Cap7.png", 3f); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/Cap7.png", 3f);
                        prop.armorPoints = 300;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Burkina Faso Mility Utility Cover - WL", 
                    DescriptionOverride = "Utility Cover", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/Cap8icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/Cap8.png", 3f); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/Cap8.png", 3f);
                        prop.armorPoints = 300;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "PASGT 1 - WL", 
                    DescriptionOverride = "Personnel Armor System for Ground Troops", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/PASGT1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/PASGT1.png", 3f); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/PASGT1.png", 3f);
                        prop.armorPoints = 300;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "PASGT 2 - WL", 
                    DescriptionOverride = "Personnel Armor System for Ground Troops", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/PASGT2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/PASGT2.png", 3f); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/PASGT2.png", 3f);
                        prop.armorPoints = 300;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "PASGT 3 - WL", 
                    DescriptionOverride = "Personnel Armor System for Ground Troops", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/PASGT3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/PASGT3.png", 3f); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/PASGT3.png", 3f);
                        prop.armorPoints = 300;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "MoTaV - WL", 
                    DescriptionOverride = "Ballistic vest adopted by the United States Military.", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/vest1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest1top.png", 3); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 2;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest1top.png", 3);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 130;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest1bottom.png", 3);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 120;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "BDU Rig + Pouches - WL", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/bduvesticon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/bduvesttop.png", 3); 

                        int PartCount = 3;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/bduvesttop.png", 3);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/bduvestmiddle.png", 3);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        armProp[1].sprite = ModAPI.LoadSprite("Armor/bduvestbottom.png", 3);
                        armProp[1].armorPiece = "LowerBody";
                        armProp[1].offset = offset;
                        armProp[1].armorTier = 2;
                        armProp[1].scaleOffset = scaleOffset;
                        armProp[1].armorPoints = 250;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Militant 11 - WL", 
                    DescriptionOverride = "Militant.", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("People/merc11icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 3;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("People/merc11.png"),                         
                            ModAPI.LoadTexture("People/merc11.png"),
                        };
                    }
                }
            );  

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Burkina Faso Anti Terrorist - WL", 
                    DescriptionOverride = "Burkina Faso anti Terrorism group.", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("People/Burk1icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 3;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("People/Burk1.png"),                         
                            ModAPI.LoadTexture("People/Burk1.png"),
                        };
                    }
                }
            );  

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Militant 1 - WL", 
                    DescriptionOverride = "combative and aggressive in support of a political or social cause, and typically favoring extreme, violent, or confrontational methods.", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("People/merc1icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 3;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("People/merc1.png"),                         
                            ModAPI.LoadTexture("People/merc1.png"),
                        };
                    }
                }
            );      
              

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Militant 2 - WL", 
                    DescriptionOverride = "combative and aggressive in support of a political or social cause, and typically favoring extreme, violent, or confrontational methods.", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("People/merc2icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 3;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("People/merc2.png"),                         
                            ModAPI.LoadTexture("People/merc2.png"),
                        };
                    }
                }
            );      
              

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Militant 3 - WL", 
                    DescriptionOverride = "combative and aggressive in support of a political or social cause, and typically favoring extreme, violent, or confrontational methods.", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("People/merc3icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 3;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("People/merc3.png"),                         
                            ModAPI.LoadTexture("People/merc3.png"),
                        };
                    }
                }
            );      
                  

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Militant 4 - WL", 
                    DescriptionOverride = "combative and aggressive in support of a political or social cause, and typically favoring extreme, violent, or confrontational methods.", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("People/merc4icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 3;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("People/merc4.png"),                         
                            ModAPI.LoadTexture("People/merc4.png"),
                        };
                    }
                }
            );      
                

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Militant 5 - WL", 
                    DescriptionOverride = "combative and aggressive in support of a political or social cause, and typically favoring extreme, violent, or confrontational methods.", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("People/merc5icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 3;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("People/merc5.png"),                         
                            ModAPI.LoadTexture("People/merc5.png"),
                        };
                    }
                }
            );      
               

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Militant 6 - WL", 
                    DescriptionOverride = "combative and aggressive in support of a political or social cause, and typically favoring extreme, violent, or confrontational methods.", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("People/merc6icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 3;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("People/merc6.png"),                         
                            ModAPI.LoadTexture("People/merc6.png"),
                        };
                    }
                }
            );      
                 

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Militant 7 - WL", 
                    DescriptionOverride = "combative and aggressive in support of a political or social cause, and typically favoring extreme, violent, or confrontational methods.", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("People/merc7icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 3;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("People/merc7.png"),                         
                            ModAPI.LoadTexture("People/merc7.png"),
                        };
                    }
                }
            );      
                

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Militant 8 - WL", 
                    DescriptionOverride = "combative and aggressive in support of a political or social cause, and typically favoring extreme, violent, or confrontational methods.", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("People/merc8icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 3;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("People/merc8.png"),                         
                            ModAPI.LoadTexture("People/merc8.png"),
                        };
                    }
                }
            );   

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Militant 10 - WL", 
                    DescriptionOverride = "combative and aggressive in support of a political or social cause, and typically favoring extreme, violent, or confrontational methods.", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("People/merc10icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 3;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("People/merc10.png"),                         
                            ModAPI.LoadTexture("People/merc10.png"),
                        };
                    }
                }
            );       
                   

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Militant 9 - WL", 
                    DescriptionOverride = "combative and aggressive in support of a political or social cause, and typically favoring extreme, violent, or confrontational methods.", 
                    CategoryOverride = ModAPI.FindCategory("WL"), 
                    ThumbnailOverride = ModAPI.LoadSprite("People/merc9fix.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 3;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("People/merc9.png"),                         
                            ModAPI.LoadTexture("People/merc9.png"),
                        };
                    }
                }
            );      
              }               
           

public class MultipleSpriteHumanBehaviour : MonoBehaviour
    {
        public Texture2D[] Textures = new Texture2D[0];
        public PersonBehaviour person;
        public int CurrentTexture = -2;
        public int Scale = 3;

        void Start()
        {
            SetTexture();
        }

        public void SetTexture()
        {
            if (Textures.Length == 0)
                return;

            if(CurrentTexture == -2)
            {
                CurrentTexture = UnityEngine.Random.Range(0, Textures.Length);
            }
            person.SetBodyTextures(Textures[CurrentTexture], null, null, Scale);
            for (int i = 0; i < person.Limbs.Length; i++)
            {
                person.Limbs[i].gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
            }
        }
}    }
}